
proc Set_V878_Options {} {
    global Options V878_Base

    load_Options

   if {![info exists Options(v878.channels)]} {set Options(v878.channels) 4096}
   if {![info exists Options(v878.offset)]} {set Options(v878.offset) 0}
   if {![info exists Options(v878.shift)]} {set Options(v878.shift) 0}
   if {![info exists Options(v878_GroupBase)]} {set Options(v878_GroupBase) $V878_Base}
   set V878_Base   $Options(v878_GroupBase)

    update_Options
}

proc Dump_Raw_VME_Data_V878 {data} {

   set info ""

      set data "$data\n"

   return $info
}

proc define_V878_config {} {
   global VMEserver
    global V878_Base

   set maxmodule [inform vmecontrol inquire v878count]
   if {[string length $maxmodule] > 2} {set maxmodule 0}
   if {$maxmodule > 0} then {DefineConfig "878 0 [format "0x%x" $V878_Base]"}

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {eg "(register :name '/$VMEserver/v878#$i.Output_Buffer'  ?object)" } m]
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to locate register v878#$i.Output_Buffer"
          clear-footer
          error $m
      }
      DefineConfig "878 $i [string range [first $m] 2 end]"
   }
}

proc create_V878_spectra {} {
    global SpectrumServer V878_Base
    global Options

   set maxmodule [inform vmecontrol inquire v878count]
   if {[string length $maxmodule] > 2} {set maxmodule 0}
   set maxadc 32

   for {set i 1} {$i <= $maxmodule} {incr i} {

    set-footer "creating spectra for module v878#$i"

    for {set j 0} {$j < $maxadc} {incr j} {

      set spectrumname [SpectrumName v878#$i.adc$j]
      set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $Options(v878.channels) :name '$spectrumname' !new)" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
      if {$z!=0 && $m==0x30004} then {set z 0}
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to create spectrum  v878#$i.adc$j"
          clear-footer
          error $m
      } else {
          set group [expr $V792_Base - 1 + $i]
          map_spectrum  "$spectrumname $group $j $Options(v878.offset) $Options(v878.shift)"
      }
    }
   }
}

